<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.6"/>
<title>TIML: Introduction</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">TIML
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.6 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li class="current"><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Data&#160;Structures</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
</div><!-- top -->
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Data Structures</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Enumerator</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Groups</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(8)"><span class="SelectionMark">&#160;</span>Pages</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">Introduction </div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><h1><a class="anchor" id="sectionOverview"></a>
Overview</h1>
<p>The Texas Instruments Machine Learning (TIML) library is C implementation of common machine learning functions optimized for TI embedded devices. Initially, the library supports convolutional neural networks (CNNs), but will grow with time in scope. The library has a minimal set of dependencies upon other libraries to simplify the installation and use.</p>
<h1><a class="anchor" id="sectionInstallation"></a>
Installation</h1>
<h2><a class="anchor" id="subsectionDependencies"></a>
Dependencies</h2>
<p><b> TIML library dependencies </b><br/>
 The TIML library requires a high performance C basic linear algebra subprogram (CBLAS) library and a library for reading Joint Photographic Experts Group (JPEG) images. An optimized CBLAS implementation is included with TI embedded devices. For pre development work on a desktop, a reference (unoptimized) CBLAS implementation can be downloaded from <a href="http://www.netlib.org/blas/blast-forum/cblas.tgz">http://www.netlib.org/blas/blast-forum/cblas.tgz</a> or in Ubuntu using the command</p>
<p><code> sudo apt-get install libatlas-base-dev </code></p>
<p>A JPEG library, libjpeg, can be downloaded from <br/>
<a href="http://sourceforge.net/projects/libjpeg/files/latest/download?source=files">http://sourceforge.net/projects/libjpeg/files/latest/download?source=files</a> <br/>
or in Ubuntu using the command</p>
<p><code> sudo apt-get install libjpeg-dev </code></p>
<p><b> Application dependencies </b><br/>
 The ImageNet database conversion application resizes all the images to size 256*256. The resizing is done using openCV. In Ubuntu, use the following command to install openCV</p>
<p><code> sudo apt-get install libopencv-dev </code></p>
<p>The interop application converts a CNN model in Caffe format to TIML CNN format. The Caffe format depends on google's protocol buffer library. To install the library, use command</p>
<p><code> sudo apt-get install libprotobuf-dev </code></p>
<h2><a class="anchor" id="subsectionDirectoryStructure"></a>
Directory Structure</h2>
<p>Install the TIML library by unzipping the zip file to a directory referred to as &lt;install_directory&gt;. At a terminal prompt, change the working directory to <code>&lt;install_directory&gt;/build</code> and use the command <code>make all</code> to compile the library. The library file will be placed inside the <code>&lt;install_directory&gt;/bin</code> folder.</p>
<p>The directory structure of the compiled library is shown as follows:</p>
<ul>
<li><code>&lt;install_directory&gt;/bin</code>: library binary file directory</li>
<li><code>&lt;install_directory&gt;/build</code>: makefile directory</li>
<li><code>&lt;install_directory&gt;/doc</code>: doxygen file directory</li>
<li><code>&lt;install_directory&gt;/src/common</code>: common library directory<ul>
<li><code>&lt;install_directory&gt;/src/common/api</code>: library API source file</li>
<li><code>&lt;install_directory&gt;/src/common/cnn</code>: cnn moudule source file</li>
<li><code>&lt;install_directory&gt;/src/common/util</code>: util moudule source file</li>
</ul>
</li>
<li><code>&lt;install_directory&gt;/src/test</code>: test module directory<ul>
<li><code>&lt;install_directory&gt;/src/test/cnn</code>: cnn test source file</li>
<li><code>&lt;install_directory&gt;/src/test/util</code>: util test source file</li>
</ul>
</li>
<li><code>&lt;install_directory&gt;/src/benchmark</code>: benchmark module directory<ul>
<li><code>&lt;install_directory&gt;/src/benchmark/cnn</code>: cnn benchmark source file<ul>
<li><code>&lt;install_directory&gt;/src/benchmark/cnn/class</code>: cnn classification benchmark source file</li>
</ul>
</li>
</ul>
</li>
<li><code>&lt;install_directory&gt;/src/app</code>: application module directory<ul>
<li><code>&lt;install_directory&gt;/src/app/cnn</code>: cnn application source file<ul>
<li><code>&lt;install_directory&gt;/src/app/cnn/class</code>: cnn classification application source file<ul>
<li><code>&lt;install_directory&gt;/src/app/cnn/class/cifar10</code>: cnn CIFAR10 database classification application source file</li>
<li><code>&lt;install_directory&gt;/src/app/cnn/class/imagenet</code>: cnn ImageNet database classification application source file</li>
<li><code>&lt;install_directory&gt;/src/app/cnn/class/mnist</code>: cnn MNIST database classification application source file</li>
</ul>
</li>
<li><code>&lt;install_directory&gt;/src/app/cnn/scene</code>: cnn scene labeling application source file<ul>
<li><code>&lt;install_directory&gt;/src/app/cnn/scene/sbd</code>: cnn stanford background dataset scene labeling application source file</li>
</ul>
</li>
<li><code>&lt;install_directory&gt;/src/app/cnn/interop</code>: cnn interoperation application source file<ul>
<li><code>&lt;install_directory&gt;/src/app/cnn/interop/caffe</code>: cnn-caffe interoperation application source file</li>
</ul>
</li>
<li><code>&lt;install_directory&gt;/src/app/cnn/convert</code>: cnn database conversion application source file<ul>
<li><code>&lt;install_directory&gt;/src/app/cnn/convert/imagenet</code>: cnn ImageNet database conversion application source file</li>
<li><code>&lt;install_directory&gt;/src/app/cnn/convert/sbd</code>: cnn SBD database conversion application source file</li>
</ul>
</li>
</ul>
</li>
</ul>
</li>
<li><code>&lt;install_directory&gt;/src/database</code>: database directory<ul>
<li>cifar10: Canadian Institute for Advanced Research-10 Class</li>
<li>imagenet: ImageNet 2012</li>
<li>mnist: Mixed National Institute of Standards and Technology</li>
<li>sbd: Stanford Background Dataset</li>
<li>model: pretrained models<ul>
<li>cifar10</li>
<li>alexnet</li>
<li>caffenet</li>
<li>vggnet</li>
<li>mnist</li>
<li>sbd</li>
</ul>
</li>
</ul>
</li>
</ul>
<h2><a class="anchor" id="subsectionDoc"></a>
Document Genearation</h2>
<p>Documents of html and pdf formats can be generated using Doxygen. Make sure you have both latex and Doxygen installed. In Ubuntu, the installation commands are</p>
<ul>
<li><code>sudo apt-get install doxygen</code></li>
<li><code>sudo apt-get install texlive-full</code></li>
</ul>
<p>Use the command <code>doxygen &lt;install- <code>&lt;install_directory&gt;/src/app/cnn/scene</code>: cnn scene labeling application source file_directory&gt;/doc/timl.Doxyfile</code> to generate the documents. The html version is located at <code>doxygen &lt;install_directory&gt;/doc/html</code>. To generate the pdf version, change the directory to <code>doxygen &lt;install_directory&gt;/doc/latex</code> and run the command <code>make</code>. A filed named refman.pdf will be generated in the currnet folder.</p>
<h2><a class="anchor" id="subsectionImageDatabases"></a>
Image Databases</h2>
<p>In order to run the examples provided by the library, it is required to download additional databases of test images.</p>
<p><b>MNIST</b></p>
<p>The MNIST database of handwritten digits, available from this page, has a training set of 60,000 examples, and a test set of 10,000 examples. It is a subset of a larger set available from NIST. The digits have been size-normalized and centered in a fixed-size image.</p>
<p>You can download the MNIST database from <a href="http://yann.lecun.com/exdb/mnist/">http://yann.lecun.com/exdb/mnist/</a> or simpliy change the directory to <code>&lt;install_directory&gt;/src/database/mnist</code> and run the script <code>./databaseMNISTDownload.sh</code>. After the download, there should be 4 files in the folder:</p>
<ul>
<li><code>t10k-images.idx3-ubyte</code></li>
<li><code>t10k-labels.idx1-ubyte</code></li>
<li><code>train-images.idx3-ubyte</code></li>
<li><code>train-labels.idx1-ubyte</code>.</li>
</ul>
<p><b>CIFAR10</b></p>
<p>The CIFAR-10 dataset consists of 60000 32x32 colour images in 10 classes, with 6000 images per class. The dataset is divided into five training batches and one test batch, each with 10000 images. The test batch contains exactly 1000 randomly-selected images from each class. The training batches contain the remaining images in random order, but some training batches may contain more images from one class than another. Between them, the training batches contain exactly 5000 images from each class.</p>
<p>You can download the CIFAR10 database from <a href="http://www.cs.toronto.edu/~kriz/cifar.html">http://www.cs.toronto.edu/~kriz/cifar.html</a> or simpliy change the directory to <code>&lt;install_directory&gt;/src/database/cifar10</code> and run the script <code>./databaseCIFAR10Download.sh</code>. After the download, there should be 6 files in the folder:</p>
<ul>
<li><code>data_batch_1.bin</code></li>
<li><code>data_batch_2.bin</code></li>
<li><code>data_batch_3.bin</code></li>
<li><code>data_batch_4.bin</code></li>
<li><code>data_batch_5.bin</code></li>
<li><code>test_batch_6.bin</code></li>
</ul>
<p><b>ImageNet</b></p>
<p>ImageNet is an image dataset organized according to the WordNet hierarchy.Each meaningful concept in WordNet, possibly described by multiple words or word phrases, is called a "synonym set" or "synset". There are more than 100,000 synsets in WordNet, majority of them are nouns (80,000+). ImageNet aims to provide on average 1000 images to illustrate each synset. Images of each concept are quality-controlled and human-annotated.</p>
<p>Download the database from <a href="http://www.image-net.org/challenges/LSVRC/2012/nonpub-downloads">http://www.image-net.org/challenges/LSVRC/2012/nonpub-downloads</a> to &lt;install_directory&gt;/database/imagnet. You need to register before you can download the database.http://dags.stanford.edu/projects/scenedataset.html</p>
<ul>
<li>Download the training images of size 138GB and MD5: 1d675b47d978889d74fa0da5fadfb00e</li>
<li>Download the validation images of size 6.3GB and MD5: 29b22e2961454d5413ddabcf34fc5622</li>
<li>Download the auxiliary files by changing the working directory to <code>&lt;install_directory&gt;/src/database/imagnet</code> and runing the script <code> ./databaseImageNetDownload.sh </code></li>
<li>Extract all the files to the &lt;install_directory&gt;/src/database/imagnet</li>
<li>Change run the script ./databaseImageNetConvert.sh to convert the raw database to a format that is ready to be processed by TIML. You may need to change the path variables in this script if you choose to store the database in other directories. You can also specify the number of images to be converted in the script.</li>
</ul>
<p>After the conversion, there should be two folders, test and train, in &lt;install_directory&gt;/src/database/imagnet. There will be a single labels.txt file in each of the folder. All the images will be resized to 256*256.</p>
<p><b>Stanford Background Dataset</b></p>
<p>The Stanford Background Dataset is a new dataset introduced in Gould et al. (ICCV 2009) for evaluating methods for geometric and semantic scene understanding. The dataset contains 715 images chosen from existing public datasets: LabelMe, MSRC, PASCAL VOC and Geometric Context. The selection criteria were for the images to be of outdoor scenes, have approximately 320-by-240 pixels, contain at least one foreground object, and have the horizon position within the image.</p>
<p>You can download the database from <a href="http://dags.stanford.edu/data/iccv09Data.tar.gz">http://dags.stanford.edu/data/iccv09Data.tar.gz</a> or simply change the working directory to <code>&lt;install_directory&gt;/src/database/sbd</code> and run the script <code>databaseSBDDownload.sh</code> To convert the database to TIML compatible format, run the script ./databaseSBDConvert.sh. You can specify the number of images used for training and testing by changing the corresponding variables in the script. After running the script, there should be two folders named "train" and "test" in the current folder.</p>
<h2><a class="anchor" id="subsectionCNNPretrainedModels"></a>
CNN Pretrained Models</h2>
<p>TIML can convert models pretrained by Caffe<a class="el" href="citelist.html#CITEREF_Caffe">[2]</a> to a format that is compatible with TIML. Caffe is a deep learning framework developed by the Berkeley Vision and Learning Center (BVLC). You can train your CNN on Caffe on CPU or GPU, save the parameters and then convert it to a format supported by TIML.</p>
<p><b> AlexNet </b><a class="el" href="citelist.html#CITEREF_AlexNet">[1]</a></p>
<p>AlexNet is a deep convolutional neural network to classify the 1.3 million high-resolution images in the LSVRC-2010 ImageNet training set into the 1000 different classes. On the test data, AlexNet achieved top-1 and top-5 error rates of 39.7% and 18.9% which is considerably better than the previous state-of-the-art results. The neural network, which has 60 million parameters and 500,000 neurons, consists of five convolutional layers, some of which are followed by max-pooling layers, and two globally connected layers with a final 1000-way softmax.</p>
<ul>
<li>Download the Caffe AlexNet binary file from <a href="http://dl.caffe.berkeleyvision.org/bvlc_alexnet.caffemodel">http://dl.caffe.berkeleyvision.org/bvlc_alexnet.caffemodel</a> to &lt;install_directory&gt;/src/database/model/alexnet</li>
<li>Download the Caffe AlexNet depoly file from <a href="https://github.com/BVLC/caffe/blob/master/models/bvlc_alexnet/deploy.prototxt">https://github.com/BVLC/caffe/blob/master/models/bvlc_alexnet/deploy.prototxt</a> to &lt;install_directory&gt;/src/database/model/alexnet</li>
<li>Run the script ./databaseModelAlexNetInterop.sh to perform the conversion</li>
</ul>
<p>After the conversion, there should two files in &lt;install_directory&gt;/database/model/alexnet:</p>
<ul>
<li>databaseModelAlexNet.m <em>A text file that defines the structure of the CNN</em></li>
<li>databaseModelAlexNet.m.params <em>A binary file that stores the parameters of the CNN</em></li>
</ul>
<p><b> CaffeNet </b></p>
<p>The CaffeNet is a replication of the model described in the AlexNet publication with some differences:</p>
<ul>
<li>not training with the relighting data-augmentation;</li>
<li>the order of pooling and normalization layers is switched (in CaffeNet, pooling is done before normalization).</li>
</ul>
<p>This model obtains a top-1 accuracy 57.4% and a top-5 accuracy 80.4% on the validation set, using just the center crop.</p>
<ul>
<li>Download the Caffe CaffeNet binary file from <a href="http://dl.caffe.berkeleyvision.org/bvlc_reference_caffenet.caffemodel">http://dl.caffe.berkeleyvision.org/bvlc_reference_caffenet.caffemodel</a> to &lt;install_directory&gt;/database/model/caffenet</li>
<li>Download the Caffe CaffeNet depoly file from <a href="https://github.com/BVLC/caffe/blob/master/models/bvlc_reference_caffenet/deploy.prototxt">https://github.com/BVLC/caffe/blob/master/models/bvlc_reference_caffenet/deploy.prototxt</a> to &lt;install_directory&gt;/src/database/model/caffenet</li>
<li>Run the script ./databaseModelCaffeNetInterop.sh to perform the conversion</li>
</ul>
<p>After the conversion, there should two files in &lt;install_directory&gt;/src/database/model/caffenet:</p>
<ul>
<li>databaseModelCaffeNet.m</li>
<li>databaseModelCaffeNet.m.params</li>
</ul>
<p><b> VGGNet </b> <a class="el" href="citelist.html#CITEREF_VGG">[3]</a></p>
<p>VGGNet shows that a significant improvement on the prior-art configurations can be achieved by increasing the depth to 16-19 weight layers, which is substantially deeper than what has been used in the prior art. To reduce the number of parameters in such very deep networks, the researchers use very small 3×3 filters in all convolutional layers.</p>
<ul>
<li>Download the VGGNet binary file from <a href="http://www.robots.ox.ac.uk/~vgg/software/very_deep/caffe/VGG_ILSVRC_16_layers.caffemodel">http://www.robots.ox.ac.uk/~vgg/software/very_deep/caffe/VGG_ILSVRC_16_layers.caffemodel</a> to &lt;install_directory&gt;/src/database/model/vggnet</li>
<li>Download the VGGNet depoly file from <a href="https://gist.githubusercontent.com/ksimonyan/211839e770f7b538e2d8/raw/0067c9b32f60362c74f4c445a080beed06b07eb3/VGG_ILSVRC_16_layers_deploy.prototxt">https://gist.githubusercontent.com/ksimonyan/211839e770f7b538e2d8/raw/0067c9b32f60362c74f4c445a080beed06b07eb3/VGG_ILSVRC_16_layers_deploy.prototxt</a> to &lt;install_directory&gt;/src/database/model/vggnet</li>
<li>Run the script ./databaseModelVGGNetInterop.sh to perform the conversion</li>
</ul>
<p>After the conversion, there should two files in &lt;install_directory&gt;/src/database/model/caffenet:</p>
<ul>
<li>databaseModelVGGNet.m</li>
<li>databaseModelVGGNet.m.params</li>
</ul>
<p><b> MNIST </b> A pretrained CNN for MNIST database is located at &lt;install_directory&gt;/src/database/model/mnist:</p>
<ul>
<li>databaseModelMNIST.m</li>
<li>databaseModelMNIST.m.params</li>
</ul>
<p><b> CIFAR10 </b> A pretrained CNN for CIFAR10 database is located at &lt;install_directory&gt;/src/database/model/cifar10:</p>
<ul>
<li>databaseModelCIFAR10.m</li>
<li>databaseModelCIFAR10.m.params</li>
</ul>
<h1><a class="anchor" id="sectionCNNs"></a>
Convolutional Neural Networks (CNNs)</h1>
<p>The TIML library provides a set of APIs that allow a user to implement a CNN architecture and perform training and testing. Common CNN layer types are supported in the current version and more will be added in future versions. Both image classification and scene labeling examples are provided.</p>
<p>This section briefly describes the use of CNN library APIs. For complete examples, refer to the folder <code>&lt;install_directory&gt;/src/app/cnn</code></p>
<h2><a class="anchor" id="subsectionTrainingParameters"></a>
Training Parameters</h2>
<p>The default training parameters structure is obtained by calling <code><a class="el" href="group__cnn.html#gaaf7a5b272ae2ba5d0453f214afaab747" title="Return the default training parameters. ">timlCNNTrainingParamsDefault()</a></code>. Default parameters can be overridden by setting specific field values (refer to <code><a class="el" href="structtimlCNNTrainingParams.html">timlCNNTrainingParams</a></code> for details).</p>
<h2><a class="anchor" id="subsectionLayers"></a>
Layers</h2>
<p>This section describes the different CNN layers supported by the TIML library. To create a CNN, call <code><a class="el" href="group__cnn.html#gaf75b4687f4b493b8a85bc7fcc37bdf18" title="Create a cnn structure. ">timlCNNCreateConvNeuralNetwork()</a></code>. Here is an example code block in <code>timlTestCNNSimpleTraining()</code> that generates a simple CNN with 8 layer types:</p>
<div class="fragment"><div class="line">trainingParams              = <a class="code" href="group__cnn.html#gaaf7a5b272ae2ba5d0453f214afaab747">timlCNNTrainingParamsDefault</a>();</div>
<div class="line">trainingParams.batchSize    = BATCH_SIZE;</div>
<div class="line">trainingParams.learningRate = 0.1;</div>
<div class="line">cnn = <a class="code" href="group__cnn.html#gaf75b4687f4b493b8a85bc7fcc37bdf18">timlCNNCreateConvNeuralNetwork</a>(trainingParams, 0);</div>
<div class="line">inputParams       = <a class="code" href="group__cnn.html#ga71b91e772f1e63528e53a6284ba7b879">timlCNNInputParamsDefault</a>();</div>
<div class="line">inputParams.scale = 1.0/256.0;</div>
<div class="line"><a class="code" href="group__cnn.html#ga253033ab06b21f2bf28301bc1e53c419">timlCNNAddInputLayer</a>(cnn, IMAGE_ROW, IMAGE_COL, IMAGE_CHANNEL, inputParams);            <span class="comment">// input layer</span></div>
<div class="line"><a class="code" href="group__cnn.html#ga772bc4b21c2f800ee8ac5248a732f116">timlCNNAddConvLayer</a>(cnn, 5, 5, 1, 1, 6, <a class="code" href="group__cnn.html#ga33ddb7145ae4e19ea52e12576f4871aa">timlCNNConvParamsDefault</a>());                    <span class="comment">// conv layer</span></div>
<div class="line"><a class="code" href="group__cnn.html#gaddfd98d23613318bdc368eac98fddf0b">timlCNNAddNonlinearLayer</a>(cnn, Util_Relu);                                               <span class="comment">// relu layer</span></div>
<div class="line"><a class="code" href="group__cnn.html#gab5dcc5ac470e15bea85f0a5570eec37d">timlCNNAddPoolingLayer</a>(cnn, 4, 4, 4, 4, CNN_MaxPooling, <a class="code" href="group__cnn.html#gacd163e268b3ccc9805bcca59689a36f5">timlCNNPoolingParamsDefault</a>()); <span class="comment">// max pooling layer</span></div>
<div class="line"><a class="code" href="group__cnn.html#ga7627fe7a5294d7c8cac75d974b78a27a">timlCNNAddNormLayer</a>(cnn, <a class="code" href="group__cnn.html#ga03ee34f7d893af02536bcbf2d071f721">timlCNNNormParamsDefault</a>());                                   <span class="comment">// norm layer</span></div>
<div class="line"><a class="code" href="group__cnn.html#gae988ef172bde701db59b1cfc33dd50ab">timlCNNAddDropoutLayer</a>(cnn, 0.5);                                                       <span class="comment">// dropout layer</span></div>
<div class="line"><a class="code" href="group__cnn.html#ga0219ba397301c5fb3eedfb64e62e33bc">timlCNNAddLinearLayer</a>(cnn, 10, <a class="code" href="group__cnn.html#gad5c8fd10f11ccaa8142a665fc8ee93b8">timlCNNLinearParamsDefault</a>());                           <span class="comment">// linear layer</span></div>
<div class="line"><a class="code" href="group__cnn.html#gaddfd98d23613318bdc368eac98fddf0b">timlCNNAddNonlinearLayer</a>(cnn, Util_Softmax);                                            <span class="comment">// softmax layer</span></div>
<div class="line"><a class="code" href="group__cnn.html#ga666fa0a68b725aa1e35dba659ba7c5f9">timlCNNInitialize</a>(cnn);</div>
<div class="line"><a class="code" href="group__cnn.html#ga21bc0c855cb658f51fe5d6911acddb54">timlCNNReset</a>(cnn);</div>
</div><!-- fragment --><h3><a class="anchor" id="subsubsectionInputLayer"></a>
Input</h3>
<p>The input layer is responsible for preprocessing the raw input data. The user can choose to crop, scale, mirror, or subtract the mean form the raw image. The required parameters are the dimensions (row, column, channel) of the feature maps in the input layer. Refer to <code><a class="el" href="group__cnn.html#ga253033ab06b21f2bf28301bc1e53c419" title="Add input layer. ">timlCNNAddInputLayer()</a></code> for more details.</p>
<h3><a class="anchor" id="subsubsectionConvolutionalLayer"></a>
Convolutional</h3>
<p>The convolutional layer performs 2D convolution or correlation between feature maps and kernels. The required parameters are the 2D kernel dimension (row, column), kernel strides along row and column and the output feature map channel. For each feature map in the previous layer, there will be a corresponding 2D kernel applied to it and links to each feature map in the next layer. Refer to <code><a class="el" href="group__cnn.html#ga772bc4b21c2f800ee8ac5248a732f116" title="Add conv layer. ">timlCNNAddConvLayer()</a></code> for more detail.</p>
<h3><a class="anchor" id="subsubsectionNonlinearLayer"></a>
Nonlinear</h3>
<p>The nonlinear layer implements 1 nonlinearity, supported types are:</p>
<ul>
<li>rectified linear unit<br/>
 <img class="formulaInl" alt="$ f(z) = \max(0, z) $" src="form_0.png"/></li>
<li>sigmoid<br/>
 <img class="formulaInl" alt="$ f(z) = \frac{1}{1+e^{-z}} $" src="form_1.png"/></li>
<li>softmax<br/>
 <img class="formulaInl" alt="$ f(z)_j = \frac{e^{-z_j}}{\sum_{i=0}^{K}e^{-z_i}} $" src="form_2.png"/></li>
<li>tanh<br/>
 <img class="formulaInl" alt="$ f(z) = \frac{e^{z}-e^{-z}}{e^{z}+e^{-z}} $" src="form_3.png"/></li>
</ul>
<p>To add a nonlinear layer to the cnn structure, call the function <code><a class="el" href="group__cnn.html#gaddfd98d23613318bdc368eac98fddf0b" title="Add nonlinear layer. ">timlCNNAddNonlinearLayer()</a></code>. Note that for image classification applications, the last layer is most commonly chosen to be a softmax nonlinear layer that output an array of class probabilities that sum up to 1.</p>
<h3><a class="anchor" id="subsubsectionPoolingLayer"></a>
Pooling</h3>
<p>The pooling layer performs a local maxing or averaging operation on the feature maps. The required parameters are the pooling kernel dimension (row, col), kernel strides along column and row and the pooling method. Refer to <code><a class="el" href="group__cnn.html#gab5dcc5ac470e15bea85f0a5570eec37d" title="Add pooling layer. ">timlCNNAddPoolingLayer()</a></code> for more details.</p>
<h3><a class="anchor" id="subsubsectionNormalizationLayer"></a>
Normalization</h3>
<p>The normalization layer performs local contrast normalization across channels:<br/>
 <img class="formulaInl" alt="$ y^i = \frac{x^i}{(1+\frac{\alpha}{N}\sum^{\min(N-1, i+N/2)}_{j=\max(0, i-N/2)}x^j)^\beta} $" src="form_4.png"/> ,where <img class="formulaInl" alt="$x^i$" src="form_5.png"/> stands for the feature map in the i-th channel. The channel span N defaults to 5. <img class="formulaInl" alt="$\alpha$" src="form_6.png"/> and <img class="formulaInl" alt="$\beta$" src="form_7.png"/> default to 0.001 and 0.75, respectively. Refer to <code><a class="el" href="group__cnn.html#ga7627fe7a5294d7c8cac75d974b78a27a" title="Add normalization layer. ">timlCNNAddNormLayer()</a></code> for more details.</p>
<h3><a class="anchor" id="subsubsectionDropoutLayer"></a>
Dropout</h3>
<p>The dropout layer is used during training to help prevent overfitting. Each element in the feature map is set to 0 (deactivated) according to a preset probability in the training phase. Note the dropout layer is simply a pass through in the testing phase. Refer to <code><a class="el" href="group__cnn.html#gae988ef172bde701db59b1cfc33dd50ab" title="Add dropout layer. ">timlCNNAddDropoutLayer()</a></code> for more details.</p>
<h3><a class="anchor" id="subsubsectionLinearLayer"></a>
Linear</h3>
<p>The linear layer is also referred to as the inner product layer or fully connected layer. A traditional neural network layer, the feature map in the previous layer is first vectorized and then multiplied by a weight matrix to obtain the feature map of next layer. The required parameter is the dimension of the output feature map. Refer to <code><a class="el" href="group__cnn.html#ga0219ba397301c5fb3eedfb64e62e33bc" title="Add linear layer. ">timlCNNAddLinearLayer()</a></code> for more details.</p>
<h2><a class="anchor" id="subsectionMemory"></a>
Memory</h2>
<p>Once the setup of the cnn structure is complete, <code><a class="el" href="group__cnn.html#ga666fa0a68b725aa1e35dba659ba7c5f9" title="Allocate the memory required by the cnn. ">timlCNNInitialize()</a></code> is called to allocate the memory. There are 3 levels of memory allocation specified inside <code><a class="el" href="structtimlCNNTrainingParams.html">timlCNNTrainingParams</a></code>.</p>
<ul>
<li>Level 1 can be used both for training and testing and requires the most memory.</li>
<li>Level 2 requires less memory but can only be used for testing.</li>
<li>Level 3 uses even less memory by operating on a memory pool and can also only be used for testing.</li>
</ul>
<p>Note that this function does not initialize the kernels or weights in the convolutional and linear layers. To perform that initialization the function <code><a class="el" href="group__cnn.html#ga21bc0c855cb658f51fe5d6911acddb54" title="Reset the parameters of the CNN. ">timlCNNReset()</a></code> is used.</p>
<p>The exact memory allocated in bytes can be obtained by calling <code><a class="el" href="group__cnn.html#ga2e8a7e765f885a236e40dfaed59913c6" title="Return the memory in bytes required by the cnn. ">timlCNNMemory()</a></code>.</p>
<p><code><a class="el" href="group__cnn.html#ga78addba765ea7dd8bf958d19d42be931" title="Resize the feature map sizes to accommodate new input feature map dimensions. ">timlCNNResize()</a></code> is used to resize the dimension of a CNN. Once the input layer dimension is changed, the dimension of the following layers will be re-calcualted and re-allocated.</p>
<p><code><a class="el" href="group__cnn.html#ga409c28e6bb3633f1de65647b790aa320" title="Clone a cnn. ">timlCNNClone()</a></code> creates a independent copy of a CNN. The function <code><a class="el" href="group__cnn.html#ga52826c14f9f1913947f5ca6937b5afd5" title="Create a new CNN that shares the parameters with the input CNN. ">timlCNNShareParams()</a></code> differs from <code><a class="el" href="group__cnn.html#ga409c28e6bb3633f1de65647b790aa320" title="Clone a cnn. ">timlCNNClone()</a></code> in that the CNN structure returned by this function allocates its own feature map memory but points to the parameter memory of its target. Therefore, <code><a class="el" href="group__cnn.html#ga52826c14f9f1913947f5ca6937b5afd5" title="Create a new CNN that shares the parameters with the input CNN. ">timlCNNShareParams()</a></code> returns a structure that takes less memory compared with the structure returned by <code><a class="el" href="group__cnn.html#ga409c28e6bb3633f1de65647b790aa320" title="Clone a cnn. ">timlCNNClone()</a></code>, which allocates its own parameter memory. The user should be careful when manipulating the shared copy of a CNN as it may write to the parameters of its target. <code><a class="el" href="group__cnn.html#ga52826c14f9f1913947f5ca6937b5afd5" title="Create a new CNN that shares the parameters with the input CNN. ">timlCNNShareParams()</a></code> is used primarily to accelerate the training and testing of a CNN. Multiple shared copies of a CNN can work in parallel by using OpenMP.</p>
<p>To free the space allocated by the CNN, call the function <code><a class="el" href="group__cnn.html#ga5af48b599237f48f016ce2060c6053e1" title="Free a cnn structure. ">timlCNNDelete()</a></code>.</p>
<h2><a class="anchor" id="subsectionUtilityFunctions"></a>
Utility Functions</h2>
<p>Utility functions aim to perform miscellaneous functions that related to IO.</p>
<p>The phase of a CNN can be set to training or testing by calling <code><a class="el" href="group__cnn.html#ga04d9a7e3725ce777402e1e5c4d5d4ce0" title="Set the phase (train/test) of the cnn. ">timlCNNSetMode()</a></code>. A CNN allocated with level 2 or 3 is not allowed to be set to the training mode as no memory is allocated to run the back propagation algorithm. In the testing mode, only forward propagation will be performed.</p>
<p>CNN structure information can be printed to the console by using <code><a class="el" href="group__cnn.html#ga123557b8025497fe266d58d80ee9983b" title="Print out the information of the cnn. ">timlCNNPrint()</a></code>. <code><a class="el" href="group__cnn.html#gaf65f8d45c892f70eeee34b47791bdcb5" title="Return the number of layers of the cnn. ">timlCNNGetLayerNum()</a></code> returns the number of layers of the CNN. <code><a class="el" href="group__cnn.html#ga72df82405eb43be8bb75373aaf8ec101" title="Get the number of parameters of the cnn. ">timlCNNGetParamsNum()</a></code> returns the total number of parameters in the CNN.</p>
<p><code><a class="el" href="group__cnn.html#gad7f3f988c763fe5a80826439c9fb08bd" title="Write the cnn to file(s) ">timlCNNWriteToFile()</a></code> writes the cnn structure into a combination of text and binary files. The key parameter of this function is the <code>timlUtilParamsLevel</code>, which specifies the level of details of the writing.</p>
<ul>
<li>Level 1 only writes the network structure to a text file without specifying the parameters or feature maps of the cnn. The text file is formatted in a syntax that is compatible with Matlab script.</li>
<li>Level 2 writes both the network structure text file and the binary parameter file.</li>
<li>Level 3 writes one more state binary files. Level 3 is only used for debugging purpose. Note that the path of the binary files to read is written into the text file.</li>
</ul>
<p>Similarly, <code><a class="el" href="group__cnn.html#gabab7c3c18a2fa4a3a9985da42662682c" title="Read CNN from file(s) ">timlCNNReadFromFile()</a></code> can be used to read a CNN from text or binary files.</p>
<p>One example of the generated text file is shown below: </p>
<div class="fragment"><div class="line">paramsBinaryFileName = <span class="stringliteral">&#39;./database/test/cnn/timl_cnn_simple_config.m.params&#39;</span>;</div>
<div class="line">stateBinaryFileName  = <span class="stringliteral">&#39;./database/test/cnn/timl_cnn_simple_config.m.state&#39;</span>;</div>
<div class="line"></div>
<div class="line">cnn.params.count          = 0;</div>
<div class="line">cnn.params.batchSize      = 100;</div>
<div class="line">cnn.params.epoch          = 1;</div>
<div class="line">cnn.params.learningRate   = 0.1000;</div>
<div class="line">cnn.params.momentum       = 0.0000;</div>
<div class="line">cnn.params.phase          = 0;</div>
<div class="line">cnn.params.allocatorLevel = 0;</div>
<div class="line">cnn.params.costType       = 0;</div>
<div class="line"></div>
<div class="line">layerNum                                    = 8;</div>
<div class="line">cnn.layer(1).id                             = 1;</div>
<div class="line">cnn.layer(1).type                           = 0;</div>
<div class="line">cnn.layer(1).row                            = 28;</div>
<div class="line">cnn.layer(1).col                            = 28;</div>
<div class="line">cnn.layer(1).channel                        = 1;</div>
<div class="line">cnn.layer(1).inputParams.row                = 28;</div>
<div class="line">cnn.layer(1).inputParams.col                = 28;</div>
<div class="line">cnn.layer(1).inputParams.channel            = 1;</div>
<div class="line">cnn.layer(1).inputParams.scale              = 1.0000;</div>
<div class="line">cnn.layer(1).inputParams.trainingCropType   = 0;</div>
<div class="line">cnn.layer(1).inputParams.trainingMirrorType = 1;</div>
<div class="line">cnn.layer(1).inputParams.testingCropType    = 0;</div>
<div class="line">cnn.layer(1).inputParams.testingMirrorType  = 1;</div>
<div class="line"></div>
<div class="line">cnn.layer(2).id                                 = 2;</div>
<div class="line">cnn.layer(2).type                               = 1;</div>
<div class="line">cnn.layer(2).row                                = 24;</div>
<div class="line">cnn.layer(2).col                                = 24;</div>
<div class="line">cnn.layer(2).channel                            = 6;</div>
<div class="line">cnn.layer(2).convParams.kernelRow               = 5;</div>
<div class="line">cnn.layer(2).convParams.kernelCol               = 5;</div>
<div class="line">cnn.layer(2).convParams.padUp                   = 0;</div>
<div class="line">cnn.layer(2).convParams.padDown                 = 0;</div>
<div class="line">cnn.layer(2).convParams.padLeft                 = 0;</div>
<div class="line">cnn.layer(2).convParams.padRight                = 0;</div>
<div class="line">cnn.layer(2).convParams.strideX                 = 1;</div>
<div class="line">cnn.layer(2).convParams.strideY                 = 1;</div>
<div class="line">cnn.layer(2).convParams.inputFeatureMapChannel  = 1;</div>
<div class="line">cnn.layer(2).convParams.outputFeatureMapChannel = 6;</div>
<div class="line">cnn.layer(2).convParams.type                    = 0;</div>
<div class="line">cnn.layer(2).convParams.kernelDecayFactor       = 1.0000;</div>
<div class="line">cnn.layer(2).convParams.kernelInit.type         = 3;</div>
<div class="line">cnn.layer(2).convParams.kernelLearningFactor    = 1.0000;</div>
<div class="line">cnn.layer(2).convParams.biasInit.type           = 0;</div>
<div class="line">cnn.layer(2).convParams.biasLearningFactor      = 1.0000;</div>
<div class="line"></div>
<div class="line">cnn.layer(3).id                   = 3;</div>
<div class="line">cnn.layer(3).type                 = 3;</div>
<div class="line">cnn.layer(3).row                  = 24;</div>
<div class="line">cnn.layer(3).col                  = 24;</div>
<div class="line">cnn.layer(3).channel              = 6;</div>
<div class="line">cnn.layer(3).nonlinearParams.type = 0;</div>
<div class="line"></div>
<div class="line">cnn.layer(4).id                     = 4;</div>
<div class="line">cnn.layer(4).type                   = 2;</div>
<div class="line">cnn.layer(4).row                    = 12;</div>
<div class="line">cnn.layer(4).col                    = 12;</div>
<div class="line">cnn.layer(4).channel                = 6;</div>
<div class="line">cnn.layer(4).poolingParams.type     = 0;</div>
<div class="line">cnn.layer(4).poolingParams.scaleRow = 2;</div>
<div class="line">cnn.layer(4).poolingParams.scaleCol = 2;</div>
<div class="line">cnn.layer(4).poolingParams.padUp    = 0;</div>
<div class="line">cnn.layer(4).poolingParams.padDown  = 0;</div>
<div class="line">cnn.layer(4).poolingParams.padLeft  = 0;</div>
<div class="line">cnn.layer(4).poolingParams.padRight = 0;</div>
<div class="line">cnn.layer(4).poolingParams.strideX  = 2;</div>
<div class="line">cnn.layer(4).poolingParams.strideY  = 2;</div>
<div class="line"></div>
<div class="line">cnn.layer(5).id                 = 5;</div>
<div class="line">cnn.layer(5).type               = 6;</div>
<div class="line">cnn.layer(5).row                = 12;</div>
<div class="line">cnn.layer(5).col                = 12;</div>
<div class="line">cnn.layer(5).channel            = 6;</div>
<div class="line">cnn.layer(5).dropoutParams.prob = 0.5000</div>
<div class="line"></div>
<div class="line">cnn.layer(6).id               = 6;</div>
<div class="line">cnn.layer(6).type             = 5;</div>
<div class="line">cnn.layer(6).row              = 12;</div>
<div class="line">cnn.layer(6).col              = 12;</div>
<div class="line">cnn.layer(6).channel          = 6;</div>
<div class="line">cnn.layer(6).normParams.type  = 0;</div>
<div class="line">cnn.layer(6).normParams.N     = 5;</div>
<div class="line">cnn.layer(6).normParams.alpha = 0.0010;</div>
<div class="line">cnn.layer(6).normParams.beta  = 0.7500;</div>
<div class="line"></div>
<div class="line">cnn.layer(7).id                                = 7;</div>
<div class="line">cnn.layer(7).type                              = 4;</div>
<div class="line">cnn.layer(7).row                               = 1;</div>
<div class="line">cnn.layer(7).col                               = 1;</div>
<div class="line">cnn.layer(7).channel                           = 10;</div>
<div class="line">cnn.layer(7).linearParams.dim                  = 10;</div>
<div class="line">cnn.layer(7).linearParams.prevDim              = 864;</div>
<div class="line">cnn.layer(7).linearParams.weightDecayFactor    = 1.0000;</div>
<div class="line">cnn.layer(7).linearParams.weightInit.type      = 3;</div>
<div class="line">cnn.layer(7).linearParams.weightLearningFactor = 1.0000;</div>
<div class="line">cnn.layer(7).linearParams.biasInit.type        = 0;</div>
<div class="line">cnn.layer(7).linearParams.biasLearningFactor   = 1.0000;</div>
<div class="line"></div>
<div class="line">cnn.layer(8).id                   = 8;</div>
<div class="line">cnn.layer(8).type                 = 3;</div>
<div class="line">cnn.layer(8).row                  = 1;</div>
<div class="line">cnn.layer(8).col                  = 1;</div>
<div class="line">cnn.layer(8).channel              = 10;</div>
<div class="line">cnn.layer(8).nonlinearParams.type = 1;</div>
</div><!-- fragment --><p>Note that the text file is formatted using Matlab syntax such that the text file can be used as a script to obtain a cnn structure object.</p>
<h2><a class="anchor" id="cnnTraining"></a>
Training</h2>
<p>The following code block in <code><a class="el" href="group__testCNN.html#gaae822c926bf3623fccbb8196504df2a1" title="Simple training function test. ">testCNNSimpleTraining()</a></code> performs training:</p>
<div class="fragment"><div class="line"><span class="comment">// read MNIST database</span></div>
<div class="line"> printf(<span class="stringliteral">&quot;2. Read the MNIST database\n&quot;</span>);</div>
<div class="line"> <a class="code" href="group__util.html#ga218c4e1b952545e65e70b46fc087c0fa">timlUtilReadMNIST</a>(DATABASE_PATH, &amp;training, &amp;testing);</div>
<div class="line"></div>
<div class="line"> <span class="comment">// training</span></div>
<div class="line"> printf(<span class="stringliteral">&quot;3. Start training\n&quot;</span>);</div>
<div class="line"> clock_gettime(CLOCK_REALTIME, &amp;startTime);</div>
<div class="line"> <span class="keywordflow">for</span> (i = 0; i &lt; batchNum; i++) {</div>
<div class="line">    <a class="code" href="group__cnn.html#ga9198f6379fad0e9e45dd8f64cc030ec3">timlCNNSupervisedTrainingWithLabelBatchMode</a>(cnn, training.data + i*batchSize*dim, training.label + i*batchSize, dim, batchSize);</div>
<div class="line"> }</div>
<div class="line"> clock_gettime(CLOCK_REALTIME, &amp;endTime);</div>
<div class="line"> trainingTime = <a class="code" href="group__util.html#gad332b3fc9cca905cb073bb950c27d9a3">timlUtilDiffTime</a>(startTime, endTime);</div>
<div class="line"> printf(<span class="stringliteral">&quot;Training time = %.2f s.\n&quot;</span>, trainingTime/1000000.0);</div>
</div><!-- fragment --><p>In this example, the training and testing image data set structures are read from the MNIST database and then passed into <code><a class="el" href="group__cnn.html#ga9198f6379fad0e9e45dd8f64cc030ec3" title="Supervised training with label. ">timlCNNSupervisedTrainingWithLabelBatchMode()</a></code>. Note that there is also a multi-thread version of this function that called <code><a class="el" href="group__cnn.html#ga9198f6379fad0e9e45dd8f64cc030ec3" title="Supervised training with label. ">timlCNNSupervisedTrainingWithLabelBatchMode()</a></code>. The training time is returned by <code><a class="el" href="group__util.html#gad332b3fc9cca905cb073bb950c27d9a3" title="Return the time difference in micro second. ">timlUtilDiffTime()</a></code> in microsecond precision.</p>
<h2><a class="anchor" id="subsectionTesting"></a>
Testing</h2>
<p>The following code block in <code>testCNNSimpleTesting()</code> performs testing:</p>
<div class="fragment"><div class="line"><span class="keywordflow">for</span>(i = 0; i &lt; testing.num; i++)</div>
<div class="line">{</div>
<div class="line">    label = <a class="code" href="group__cnn.html#gafda5077b0d39c278469278b37f845aed">timlCNNClassifyTop1SingleMode</a>(cnn, testing.data + i*dim, dim);</div>
<div class="line">    <span class="keywordflow">if</span> (label != testing.label[i]) misClassifyNum++;</div>
<div class="line">}</div>
</div><!-- fragment --><p><code><a class="el" href="group__cnn.html#gafda5077b0d39c278469278b37f845aed" title="Classify the data. ">timlCNNClassifyTop1SingleMode()</a></code> returns the top 1 label generated by the CNN. A similar function <code><a class="el" href="group__cnn.html#ga8b59ecbca36e54cfa1df0766ece686b5" title="Batch classification. ">timlCNNClassifyTopNBatchMode()</a></code> that returns the top N labels together with their corresponding probabilities for a batch of data. Note that there is also a multi-thread version of this function called <code><a class="el" href="group__cnn.html#ga4bb1537483995068ac4d250e9e8a7615" title="Batch classification using openmp. ">timlCNNClassifyTopNBatchModeOpenMP()</a></code> that classifies a batch of images using OpenMP.</p>
<h1><a class="anchor" id="sectionApplications"></a>
Applications</h1>
<p>Application source code is located at <code>&lt;install_directory&gt;/src/app</code>. To run the applications, change the directory to the corresponding binary files and run the applications.<br/>
 There are 1 application example for Caffe to TIML CNN model interoperation:</p>
<ul>
<li><code>appCNNInteropCaffe</code>: Caffe interoperation</li>
</ul>
<p>There are 2 application example for Caffe to TIML CNN database conversion:</p>
<ul>
<li><code>appCNNConvertImageNet</code>: ImagNet conversion</li>
<li><code>appCNNConvertSBD</code>: SBD conversion</li>
</ul>
<p>There are 8 application examples for CNN classification:</p>
<ul>
<li><code><a class="el" href="group__appCNNClass.html#ga74ae1f2ec0bb9e1cfc344cdfd204f4da" title="MNIST training example. ">appCNNClassMNISTTraining()</a></code>: MNIST database training</li>
<li><code><a class="el" href="group__appCNNClass.html#gafa188db78d9c7794ae1bac7a8c93cb3a" title="MNIST classification testing example. ">appCNNClassMNISTTesting()</a></code>: MNIST database testing</li>
<li><code><a class="el" href="group__appCNNClass.html#gac0aaedb9badf585311124c33751ee778" title="CIFAR10 training example. ">appCNNClassCIFAR10Training()</a></code>: CIFAR10 database training</li>
<li><code><a class="el" href="group__appCNNClass.html#gaff0f3476d60a46eeb68eae09d6df964a" title="CIFAR10 testing example. ">appCNNClassCIFAR10Testing()</a></code>: CIFAR10 database testing</li>
<li><code>appCNNClassCaffeNetTraining()</code>: CaffeNet database training</li>
<li><code>appCNNClassCaffeNetTesting()</code>: CaffeNet database testing</li>
<li><code>appCNNClassAlexNetTesting()</code>: AlexNet database training</li>
<li><code>appCNNClassVGGNetTesting()</code>: VGGNet database testing</li>
</ul>
<p>There are 2 application examples for CNN scene labeling:</p>
<ul>
<li><code><a class="el" href="group__appCNNScene.html#ga38cb0fe9d4fb06709a7e9330911c9431" title="Scene labeling training example. ">appCNNSceneSBDTraining()</a></code>: scene labeling database training</li>
<li><code><a class="el" href="group__appCNNScene.html#gaa2f9ce79a0aaf4a15ef414ac09f0ca7d" title="Standford Backgournd Database Scene labeling testing example. ">appCNNSceneSBDTesting()</a></code>: scene labeling database testing</li>
</ul>
<h2><a class="anchor" id="subsectionClassification"></a>
Classification</h2>
<p>Training and testing a CNN for image classification is very straightforward to implement using the TIML library. Let's take the MNIST database for example. Here is one code block in <code><a class="el" href="group__appCNNClass.html#ga74ae1f2ec0bb9e1cfc344cdfd204f4da" title="MNIST training example. ">appCNNClassMNISTTraining()</a></code>. There are 3 major steps. First, build up the CNN structure using the library API. Next, read the database. Third, apply the training function on the database. After the training, you can write the trained network to file(s) using <code><a class="el" href="group__cnn.html#gad7f3f988c763fe5a80826439c9fb08bd" title="Write the cnn to file(s) ">timlCNNWriteToFile()</a></code>. </p>
<div class="fragment"><div class="line"><span class="comment">// setup CNN</span></div>
<div class="line">printf(<span class="stringliteral">&quot;1. Build up the CNN\n&quot;</span>);</div>
<div class="line"><a class="code" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn = <a class="code" href="group__cnn.html#gaf75b4687f4b493b8a85bc7fcc37bdf18">timlCNNCreateConvNeuralNetwork</a>(<a class="code" href="group__cnn.html#gaaf7a5b272ae2ba5d0453f214afaab747">timlCNNTrainingParamsDefault</a>(), 0);</div>
<div class="line">cnn-&gt;params.learningRate = LEARN_RATE;</div>
<div class="line">cnn-&gt;params.<a class="code" href="structtimlCNNTrainingParams.html#a92c1f02fac7360a8aa865736f27b684a">batchSize</a>    = BATCH_SIZE;</div>
<div class="line">inputParams = <a class="code" href="group__cnn.html#ga71b91e772f1e63528e53a6284ba7b879">timlCNNInputParamsDefault</a>();</div>
<div class="line">inputParams.scale = 1.0/256.0;</div>
<div class="line"><a class="code" href="group__cnn.html#ga253033ab06b21f2bf28301bc1e53c419">timlCNNAddInputLayer</a>(cnn, IMAGE_ROW, IMAGE_COL, IMAGE_CHANNEL, inputParams);             <span class="comment">// input layer</span></div>
<div class="line">convParams = <a class="code" href="group__cnn.html#ga33ddb7145ae4e19ea52e12576f4871aa">timlCNNConvParamsDefault</a>();</div>
<div class="line">convParams.kernelInit.type = Util_Xavier;</div>
<div class="line"><a class="code" href="group__cnn.html#ga772bc4b21c2f800ee8ac5248a732f116">timlCNNAddConvLayer</a>(cnn, 5, 5, 1, 1, 20, convParams);                                    <span class="comment">// conv layer</span></div>
<div class="line">poolingParams = <a class="code" href="group__cnn.html#gacd163e268b3ccc9805bcca59689a36f5">timlCNNPoolingParamsDefault</a>();</div>
<div class="line"><a class="code" href="group__cnn.html#gab5dcc5ac470e15bea85f0a5570eec37d">timlCNNAddPoolingLayer</a>(cnn, 2, 2, 2, 2, CNN_MaxPooling, poolingParams);                  <span class="comment">// max pooling layer</span></div>
<div class="line">convParams = <a class="code" href="group__cnn.html#ga33ddb7145ae4e19ea52e12576f4871aa">timlCNNConvParamsDefault</a>();</div>
<div class="line">convParams.kernelInit.type = Util_Xavier;</div>
<div class="line"><a class="code" href="group__cnn.html#ga772bc4b21c2f800ee8ac5248a732f116">timlCNNAddConvLayer</a>(cnn, 5, 5, 1, 1, 50, convParams);                                    <span class="comment">// conv layer</span></div>
<div class="line"><a class="code" href="group__cnn.html#gab5dcc5ac470e15bea85f0a5570eec37d">timlCNNAddPoolingLayer</a>(cnn, 2, 2, 2, 2, CNN_MaxPooling, <a class="code" href="group__cnn.html#gacd163e268b3ccc9805bcca59689a36f5">timlCNNPoolingParamsDefault</a>());  <span class="comment">// max pooling layer</span></div>
<div class="line"><a class="code" href="group__cnn.html#ga0219ba397301c5fb3eedfb64e62e33bc">timlCNNAddLinearLayer</a>(cnn, 500, <a class="code" href="group__cnn.html#gad5c8fd10f11ccaa8142a665fc8ee93b8">timlCNNLinearParamsDefault</a>());                           <span class="comment">// linear layer</span></div>
<div class="line"><a class="code" href="group__cnn.html#gaddfd98d23613318bdc368eac98fddf0b">timlCNNAddNonlinearLayer</a>(cnn, Util_Relu);                                                <span class="comment">// relu layer</span></div>
<div class="line"><a class="code" href="group__cnn.html#ga0219ba397301c5fb3eedfb64e62e33bc">timlCNNAddLinearLayer</a>(cnn, 10, <a class="code" href="group__cnn.html#gad5c8fd10f11ccaa8142a665fc8ee93b8">timlCNNLinearParamsDefault</a>());                            <span class="comment">// linear layer</span></div>
<div class="line"><a class="code" href="group__cnn.html#gaddfd98d23613318bdc368eac98fddf0b">timlCNNAddNonlinearLayer</a>(cnn, Util_Softmax);                                             <span class="comment">// softmax layer</span></div>
<div class="line"><a class="code" href="group__cnn.html#ga666fa0a68b725aa1e35dba659ba7c5f9">timlCNNInitialize</a>(cnn);</div>
<div class="line"><a class="code" href="group__cnn.html#ga21bc0c855cb658f51fe5d6911acddb54">timlCNNReset</a>(cnn);</div>
<div class="line">mem = <a class="code" href="group__cnn.html#ga2e8a7e765f885a236e40dfaed59913c6">timlCNNMemory</a>(cnn);</div>
<div class="line"><a class="code" href="group__cnn.html#ga123557b8025497fe266d58d80ee9983b">timlCNNPrint</a>(cnn);</div>
<div class="line">printf(<span class="stringliteral">&quot;CNN memory allocation = %.10f MB.\n&quot;</span>, (<span class="keywordtype">float</span>) mem/1024.0/1024.0);</div>
<div class="line">printf(<span class="stringliteral">&quot;CNN parameter #       = %ld.\n&quot;</span>, <a class="code" href="group__cnn.html#ga72df82405eb43be8bb75373aaf8ec101">timlCNNGetParamsNum</a>(cnn));</div>
<div class="line"></div>
<div class="line"><span class="comment">// read MNIST database</span></div>
<div class="line">printf(<span class="stringliteral">&quot;2. Read the MNIST database\n&quot;</span>);</div>
<div class="line"><a class="code" href="group__util.html#ga218c4e1b952545e65e70b46fc087c0fa">timlUtilReadMNIST</a>(DATABASE_PATH, &amp;training, &amp;testing);</div>
<div class="line"></div>
<div class="line"><span class="comment">// training</span></div>
<div class="line">printf(<span class="stringliteral">&quot;3. Start training\n&quot;</span>);</div>
<div class="line">clock_gettime(CLOCK_REALTIME, &amp;startTime);</div>
<div class="line"><span class="keywordflow">for</span> (i = 0; i &lt; batchNum; i++) {</div>
<div class="line">   <a class="code" href="group__cnn.html#ga9198f6379fad0e9e45dd8f64cc030ec3">timlCNNSupervisedTrainingWithLabelBatchMode</a>(cnn, training.data + i*batchSize*dim, training.label + i*batchSize, dim, batchSize);</div>
<div class="line">}</div>
<div class="line">clock_gettime(CLOCK_REALTIME, &amp;endTime);</div>
<div class="line">trainingTime = <a class="code" href="group__util.html#gad332b3fc9cca905cb073bb950c27d9a3">timlUtilDiffTime</a>(startTime, endTime);</div>
<div class="line">printf(<span class="stringliteral">&quot;Training time = %.2f s.\n&quot;</span>, trainingTime/1000000.0);</div>
</div><!-- fragment --><p> Deploying or testing the CNN is even simpler. Here is one code block in <code><a class="el" href="group__appCNNClass.html#gafa188db78d9c7794ae1bac7a8c93cb3a" title="MNIST classification testing example. ">appCNNClassMNISTTesting()</a></code>. Again, there are 3 major steps. First, read the CNN structure from file(s). Next, read the testing database. Third, apply the testing function to produced the labels generated by the CNN. </p>
<div class="fragment"><div class="line"><span class="comment">// read CNN config</span></div>
<div class="line">printf(<span class="stringliteral">&quot;1. Read CNN config\n&quot;</span>);</div>
<div class="line"><a class="code" href="struct__timlConvNeuralNetwork__.html">timlConvNeuralNetwork</a> *cnn = <a class="code" href="group__cnn.html#gabab7c3c18a2fa4a3a9985da42662682c">timlCNNReadFromFile</a>(MODEL_PATH, 0);</div>
<div class="line"><a class="code" href="group__cnn.html#ga04d9a7e3725ce777402e1e5c4d5d4ce0">timlCNNSetMode</a>(cnn, Util_Tes@subsection subsectionSceneLabeling Scene Labelingt);</div>
<div class="line">mem = <a class="code" href="group__cnn.html#ga2e8a7e765f885a236e40dfaed59913c6">timlCNNMemory</a>(cnn);</div>
<div class="line"><a class="code" href="group__cnn.html#ga123557b8025497fe266d58d80ee9983b">timlCNNPrint</a>(cnn);</div>
<div class="line">printf(<span class="stringliteral">&quot;CNN memory allocation = %.10f MB.\n&quot;</span>, (<span class="keywordtype">float</span>)mem/1024.0/1024.0);</div>
<div class="line">printf(<span class="stringliteral">&quot;CNN parameter #       = %lu.\n&quot;</span>, <a class="code" href="group__cnn.html#ga72df82405eb43be8bb75373aaf8ec101">timlCNNGetParamsNum</a>(cnn));</div>
<div class="line"></div>
<div class="line"><span class="comment">// read MNIST database</span></div>
<div class="line">printf(<span class="stringliteral">&quot;2. Read MNIST database\n&quot;</span>);</div>
<div class="line"><a class="code" href="group__util.html#ga218c4e1b952545e65e70b46fc087c0fa">timlUtilReadMNIST</a>(DATABASE_PATH, &amp;training, &amp;testing);</div>
<div class="line"></div>
<div class="line"><span class="comment">// testing</span></div>
<div class="line">printf(<span class="stringliteral">&quot;3. Start testing\n&quot;</span>);</div>
<div class="line">clock_gettime(CLOCK_REALTIME, &amp;startTime);</div>
<div class="line"><a class="code" href="group__cnn.html#ga8b59ecbca36e54cfa1df0766ece686b5">timlCNNClassifyTopNBatchMode</a>(cnn, testing.data, dim, testing.num, label, NULL, topN);</div>
<div class="line">clock_gettime(CLOCK_REALTIME, &amp;endTime);</div>
<div class="line">testingTime = <a class="code" href="group__util.html#gad332b3fc9cca905cb073bb950c27d9a3">timlUtilDiffTime</a>(startTime, endTime);</div>
<div class="line">classifyNum = <a class="code" href="group__util.html#ga64e5197e9d131870e97cd510b3f499ac">timlUtilClassifyAccuracy</a>(label, topN, testing.num, testing.label);</div>
<div class="line">classifyPercent = (float)classifyNum/(<span class="keywordtype">float</span>)testing.num;</div>
<div class="line">printf(<span class="stringliteral">&quot;Testing time      = %.3f s\n&quot;</span>, testingTime/1000000.0);</div>
<div class="line">printf(<span class="stringliteral">&quot;Classify accuracy = %.3f %%\n&quot;</span>, classifyPercent*100.00);</div>
</div><!-- fragment --><h2><a class="anchor" id="subsectionSceneLabeling"></a>
Scene Labeling</h2>
<p>Scene labeling consists in labeling each pixel in an image with the category of the object it belongs to. Instread of producing one lable for the entire image, scene labeling produces one label for each pixel in the image. Therefore, training a CNN for scene labeling is slightly different from training a CNN for classification purpose. The setup of the CNN follows the same procedure:</p>
<div class="fragment"><div class="line"><span class="comment">// build up the CNN</span></div>
<div class="line">printf(<span class="stringliteral">&quot;1. Build up the CNN\n&quot;</span>);</div>
<div class="line">cnn = <a class="code" href="group__cnn.html#gaf75b4687f4b493b8a85bc7fcc37bdf18">timlCNNCreateConvNeuralNetwork</a>(<a class="code" href="group__cnn.html#gaaf7a5b272ae2ba5d0453f214afaab747">timlCNNTrainingParamsDefault</a>(), 0);</div>
<div class="line"><a class="code" href="group__cnn.html#ga253033ab06b21f2bf28301bc1e53c419">timlCNNAddInputLayer</a>(cnn, PATCH_SIZE, PATCH_SIZE, IMAGE_CHANNEL, <a class="code" href="group__cnn.html#ga71b91e772f1e63528e53a6284ba7b879">timlCNNInputParamsDefault</a>());</div>
<div class="line"><a class="code" href="group__cnn.html#ga772bc4b21c2f800ee8ac5248a732f116">timlCNNAddConvLayer</a>(cnn, 6, 6, 1, 1, 25, <a class="code" href="group__cnn.html#ga33ddb7145ae4e19ea52e12576f4871aa">timlCNNConvParamsDefault</a>());                    <span class="comment">// conv layer</span></div>
<div class="line"><a class="code" href="group__cnn.html#gaddfd98d23613318bdc368eac98fddf0b">timlCNNAddNonlinearLayer</a>(cnn, Util_Tanh);                                                <span class="comment">// tanh layer</span></div>
<div class="line"><a class="code" href="group__cnn.html#gab5dcc5ac470e15bea85f0a5570eec37d">timlCNNAddPoolingLayer</a>(cnn, 8, 8, 8, 8, CNN_MaxPooling, <a class="code" href="group__cnn.html#gacd163e268b3ccc9805bcca59689a36f5">timlCNNPoolingParamsDefault</a>());  <span class="comment">// max pooling layer</span></div>
<div class="line"><a class="code" href="group__cnn.html#ga772bc4b21c2f800ee8ac5248a732f116">timlCNNAddConvLayer</a>(cnn, 3, 3, 1, 1, 50, <a class="code" href="group__cnn.html#ga33ddb7145ae4e19ea52e12576f4871aa">timlCNNConvParamsDefault</a>());                    <span class="comment">// conv layer</span></div>
<div class="line"><a class="code" href="group__cnn.html#gaddfd98d23613318bdc368eac98fddf0b">timlCNNAddNonlinearLayer</a>(cnn, Util_Tanh);                                                <span class="comment">// tanh layer</span></div>
<div class="line"><a class="code" href="group__cnn.html#gab5dcc5ac470e15bea85f0a5570eec37d">timlCNNAddPoolingLayer</a>(cnn, 2, 2, 2, 2, CNN_MaxPooling, <a class="code" href="group__cnn.html#gacd163e268b3ccc9805bcca59689a36f5">timlCNNPoolingParamsDefault</a>());  <span class="comment">// max pooling layer</span></div>
<div class="line"><a class="code" href="group__cnn.html#ga0219ba397301c5fb3eedfb64e62e33bc">timlCNNAddLinearLayer</a>(cnn, 8, <a class="code" href="group__cnn.html#gad5c8fd10f11ccaa8142a665fc8ee93b8">timlCNNLinearParamsDefault</a>());                             <span class="comment">// linear layer</span></div>
<div class="line"><a class="code" href="group__cnn.html#gaddfd98d23613318bdc368eac98fddf0b">timlCNNAddNonlinearLayer</a>(cnn, Util_Softmax);                                             <span class="comment">// softmax layer</span></div>
</div><!-- fragment --><p>The second step is to setup the training database: </p>
<div class="fragment"><div class="line">slTraining.num              = TRAIN_IMAGE_NUM;</div>
<div class="line">slTraining.row              = IMAGE_ROW;</div>
<div class="line">slTraining.col              = IMAGE_COL;</div>
<div class="line">slTraining.channel          = IMAGE_CHANNEL;</div>
<div class="line">slTraining.patchSize        = PATCH_SIZE;</div>
<div class="line">slTraining.imageFileNameStr = TRAIN_IMAGE_PATH;</div>
<div class="line">slTraining.labelFileNameStr = TRAIN_LABEL_PATH;</div>
</div><!-- fragment --><p>In this example, 450 images are used for training and 143 images are used for testing. The dimension of the images are 240*320*3. There are 450 text file labels in the training database, each with a 240*320 label matrix. The label integer ranges from -1 to 7 (8 classes) with -1 indicating an unlabeled pixel. The image and label text file name must follow the format as indicated in the imageFileNameStr and labelFileNameStr. For each pixel in the image, a 133*133 patch centered at the pixel is passed into the CNN to output a label.</p>
<p>To train the database, the CNN first randomly selects an image and then randomly selects a pixel. Next, a patch centered at that pixel is passed to the CNN for training. The pixels are randomly selected without replacement, with 240*320*450 iterations needed to sweep through the entire database 1x. There is a specialized training function: </p>
<div class="fragment"><div class="line"><a class="code" href="group__appCNNScene.html#gaf308ce265a25eed146051684e2da2671">appCNNSceneSupervisedTraining</a>(cnn, &amp;slTraining);</div>
</div><!-- fragment --><p>To test one image, a natural way is to generate a patch for each pixel which requires 240*320 forward passes through the CNN. However, there is more efficient way to do this which exploits the convolutional structure. First, pad zeros on the test image and shift the image in all four directions. The number of shifted and zero padded images is proportional to the number of pooling layers in the CNN. Next, pass the shifted and zero padded image to the trained CNN. Finally, merge the output feature maps into a label matrix for the image. Using this approach, the input feature map size is no longer the patch size which is 133*133 in the above example. We need to re-calculate the input feature map dimensions and use function <code><a class="el" href="group__cnn.html#ga78addba765ea7dd8bf958d19d42be931" title="Resize the feature map sizes to accommodate new input feature map dimensions. ">timlCNNResize()</a></code> to resize the CNN. Note that the above cnn has gone through 2 max pooling layers which scales down the feature map by a factor of 2*8 in the row and column dimensions. The formula to calculate the resized row and col for the input layer is: </p>
<div class="fragment"><div class="line">printf(<span class="stringliteral">&quot;3. Resize the feature maps\n&quot;</span>);</div>
<div class="line">resolutionLossRow = 8*2; <span class="comment">// resolution loss due to max pooling</span></div>
<div class="line">resolutionLossCol = 8*2; <span class="comment">// resolution loss due to max pooling</span></div>
<div class="line">resizeRow = slTraining.row + (slTraining.patchSize/2)*2 - (resolutionLossRow - 1);</div>
<div class="line">resizeCol = slTraining.col + (slTraining.patchSize/2)*2 - (resolutionLossCol - 1);</div>
<div class="line"><a class="code" href="group__cnn.html#ga78addba765ea7dd8bf958d19d42be931">timlCNNResize</a>(cnn, resizeRow, resizeCol, slTraining.channel);</div>
</div><!-- fragment --><p>Multiple forward passes through the same CNN can be performed in parallel. First, create multilple shared copies of the CNN to form a team called cnnTeam. Then we can call the function <code><a class="el" href="group__appCNNScene.html#gad77aeeb63649011f260d9c475bef945d" title="Supervised training on the dataset using openmp. ">appCNNSceneClassifyOpenMP()</a></code> to perform the labeling operation. A single-thread version of the function also exists as <code><a class="el" href="group__appCNNScene.html#ga4924a13edce94afaba52667d78ef7256" title="Pixel label classification. ">appCNNSceneClassify()</a></code>; The parameter scale in <code><a class="el" href="group__appCNNScene.html#gad77aeeb63649011f260d9c475bef945d" title="Supervised training on the dataset using openmp. ">appCNNSceneClassifyOpenMP()</a></code> stands for the scale down factor of the generated label matrix. When scale == 1, no downscaling is performed. When scale == 4, the generated label matrix would be of size 60*80 and then upscaled to 240*320 to match the size of the image. Downscaling can effectively reduce the labeling time.</p>
<div class="fragment"><div class="line"><span class="comment">// create cnnTeam</span></div>
<div class="line">cnnTeam[0] = cnn;</div>
<div class="line"><span class="keywordflow">for</span> (i = 1; i &lt; thread; i++) {</div>
<div class="line">   cnnTeam[i] = <a class="code" href="group__cnn.html#ga52826c14f9f1913947f5ca6937b5afd5">timlCNNShareParams</a>(cnn, 0);</div>
<div class="line">}</div>
<div class="line"></div>
<div class="line"><span class="comment">// testing</span></div>
<div class="line">printf(<span class="stringliteral">&quot;2. Start testing\n&quot;</span>);</div>
<div class="line"><span class="keywordflow">for</span> (i = 0; i &lt; slTesting.num; i++) {</div>
<div class="line">   printf(<span class="stringliteral">&quot;Read image %03d.jpg\n&quot;</span>, i);</div>
<div class="line">   sprintf(str, slTesting.imageFileNameStr, i);</div>
<div class="line">   <a class="code" href="group__util.html#ga4e3a2beb9a301e6c71f5c1df09d6099e">timlUtilReadFixedSizeJPEG</a>(str, image, slTesting.row, slTesting.col, slTesting.channel);</div>
<div class="line">   clock_gettime(CLOCK_REALTIME, &amp;startTime);</div>
<div class="line">   <a class="code" href="group__appCNNScene.html#gad77aeeb63649011f260d9c475bef945d">appCNNSceneClassifyOpenMP</a>(cnnTeam, thread, image, slTesting.row, slTesting.col, slTesting.channel, labelMatrix, scale);</div>
<div class="line">   clock_gettime(CLOCK_REALTIME, &amp;endTime);</div>
<div class="line">   testingTime = <a class="code" href="group__util.html#gad332b3fc9cca905cb073bb950c27d9a3">timlUtilDiffTime</a>(startTime, endTime);</div>
<div class="line"></div>
<div class="line">   <span class="comment">// read true label</span></div>
<div class="line">   sprintf(str, slTesting.labelFileNameStr, i);</div>
<div class="line">   fp = fopen(str, <span class="stringliteral">&quot;rt&quot;</span>);</div>
<div class="line">   <span class="keywordflow">for</span> (n = 0; n &lt; slTesting.row; n++) {</div>
<div class="line">      <span class="keywordflow">for</span> (m = 0; m &lt; slTesting.col; m++) {</div>
<div class="line">         fscanf(fp, <span class="stringliteral">&quot;%d&quot;</span>, trueLabelMatrix + n*slTesting.col + m);</div>
<div class="line">      }</div>
<div class="line">      fscanf(fp, <span class="stringliteral">&quot;\n&quot;</span>);</div>
<div class="line">   }</div>
<div class="line">   fclose(fp);</div>
<div class="line"></div>
<div class="line">   <span class="comment">// calculate accuracy</span></div>
<div class="line">   labelAccuracy = <a class="code" href="group__appCNNScene.html#ga656def3c972943463bee38f746074b79">appCNNSceneAccuracy</a>(labelMatrix, trueLabelMatrix, slTesting.row*slTesting.col);</div>
<div class="line">   printf(<span class="stringliteral">&quot;Test image %03d label accuracy = %.2f %%\n&quot;</span>, i, 100.0*labelAccuracy);</div>
<div class="line">   printf(<span class="stringliteral">&quot;Test image %03d time           = %.3f s\n&quot;</span>, i, testingTime/1000000.0);</div>
<div class="line">}</div>
</div><!-- fragment --><h1><a class="anchor" id="sectionBenchmarks"></a>
Benchmarks</h1>
<p>The benchmark source code is located at <code>&lt;install_directory&gt;/src/benchmark</code>.</p>
<p>There are 2 examples for CNN classification benchmark:</p>
<ul>
<li><code><a class="el" href="group__benchmarkCNNClass.html#ga9417402a234aae9eb184bda7d9c293a7" title="CNN CaffeNet classification benchmark. ">benchmarkCNNClassCaffeNetTesting()</a></code> : CaffeNet benchmark</li>
<li><code><a class="el" href="group__benchmarkCNNClass.html#ga83c37557afa0f2361fd24c3f4f01603c" title="CNN VGGNet classification benchmark. ">benchmarkCNNClassVGGNetTesting()</a></code> : VGGNet benchmark</li>
</ul>
<p>These two functions will benchmark the memory usage and processing time for each individual layers in the network. </p>
</div></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Fri Mar 20 2015 11:26:10 for TIML by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.6
</small></address>
</body>
</html>
